#/usr/bin/env python
# -*- coding: utf-8 -*-

# Laden mit: execfile('Field-Compute.py')

# (c) Jonas Bechtel 2017

#FIELD_TYPES = ['PAGE', 'PAGEREF', 'SET', 'GET', 'CNT', 'CHP', 'MARK'];

# Achtung: wenn ein Feld kommentiert werden soll, bitte unbedingt die beiden Rauten ## 
# auseinandernehmen: ## -> #*# oder #//# o. ä., bis die Methode schöner gedacht wird!
# Don't use up-going apostrophes at all! (Those:´´´)

# Ausgabe in umgekehrter polnischer Notation.
# Die Positionen der Werte der Sub-Level sind auf die Inhaltsstrings der höheren
#	Level bezogen, nicht auf den Anfangstext.

# ACHTUNG: die Demo ist veraltet; zusätzlich werden auch die absoluten
#	Positionen (also die auf den Anfangstext bezogenen) gezeigt.
#>>> getFields("abc##PAGE(df##PAGEREF(bla))");
#[[], 
#	[1, 'PAGEREF', 'bla', 2, 12, 15],
#	[0, 'PAGE', 'df##PAGEREF(bla)', 3, 10, 26]]
#>>> getFields("abc##PAGE(df##PAGEREF(##PAGE(X)bla)+##PAGE(y)), PAGE(z)");
#[[],
#	[2, 'PAGE', 'X', 0, 7, 8],
#	[1, 'PAGEREF', '##PAGE(X)bla', 2, 12, 24],
#	[1, 'PAGE', 'y', 26, 33, 34],
#	[0, 'PAGE', 'df##PAGEREF(##PAGE(X)bla)+##PAGE(y)', 3, 10, 45]]
#>>> getFields("abc##PAGE(df##PAGEREF(##PAGE(X)bla)+##PAGE(y)), ##PAGE(z)");
#[[],
#	[2, 'PAGE', 'X', 0, 7, 8],
#	[1, 'PAGEREF', '##PAGE(X)bla', 2, 12, 24],
#	[1, 'PAGE', 'y', 26, 33, 34],
#	[0, 'PAGE', 'df##PAGEREF(##PAGE(X)bla)+##PAGE(y)', 3, 10, 45],
#	[0, 'PAGE', 'z', 48, 55, 56]]
#>>> 
def getFields(text, FIELD_TYPES):
	brmatch = ['([{<>', ')]}><']; # Leider nicht möglich: ` und ´, da Mehrbyte-Konstruktionen
	start = int(0);
	fields = [[]];
	recursion = [];
	last_r = 0;
	ftypes=[];
	fbrs=[]; fbr = '@';
	rec_back = 0;
	
	while True:
	#	print 'Recursion {}...'.format(len(recursion));
		# Mich beschleicht das Gefühl, dass das hier einmal zu viel verschachtelt ist.
		if (rec_back):
			if (len(recursion) == 0):
				break;
			foundl = recursion.pop();
			ftype = ftypes.pop();
			fbr = fbrs.pop();
		else:
	#		print '                       start={}           .'.format(start);
	#		print '                       {}...'.format(text[start:start+50]);
			foundl = -1;
			for i in range(len(FIELD_TYPES)):
				
				foundl2 = -2;
				field_type_search_offset = 0;
				
				while foundl2 != -1:
					foundl2 = text.find('##' + FIELD_TYPES[i], start + field_type_search_offset);
					if (foundl2 == -1):
						break;
					field_type_search_offset += foundl2 -start + 1;
	#				print [foundl2, start, field_type_search_offset];
					num_br = brmatch[0].find(text[foundl2+2+len(FIELD_TYPES[i]):foundl2+2+len(FIELD_TYPES[i])+1]);
					if (num_br != -1):
						break;
				
				
				#print 'foundl={}, foundl2={}.'.format(foundl, foundl2);
				
				if (0 <= foundl2 and (foundl == -1 or foundl2 < foundl)):
					foundl = foundl2;
					ftype = FIELD_TYPES[i];
	#				print 'Bracket: {}...{}'.format(brmatch[0][num_br], brmatch[1][num_br]);
					br = num_br;
					add_start = field_type_search_offset;
	#				print 'Gefunden (a): "{}" bei {}.'.format(FIELD_TYPES[i], foundl2);
			
			if (foundl == -1):
				rec_back = 1;
				continue;
			
			if (len(recursion)):
				
			# TODO: peek fbr from fbrs.
	#			print ' Old fbr: {}'.format(fbrs[len(recursion)-1]);
				foundr = text.find(fbrs[len(recursion)-1], start); # fbr is here: the _old_ bracket.
			#foundr = text.find(')', start);
			else:
				foundr = -1;
			if (0 < foundr and foundr < foundl):
				if (len(recursion)):
					rec_back = 1;
					continue;
					# TODO: Hier debuggen!
				# We could also break now:
				start = foundr + 1;
				continue;
		#	print foundl;
			start = foundl + 3 + len(ftype);
			fbr = brmatch[1][br];
	#		print 'Matching bracket will be "{}" ({}).'.format(fbr, br);
			
		
		foundl2 = text.find('##', start); # Here's the second search -> doesn't make sense that we look two times for ## and )]}...
		foundr = text.find(fbr, start);
	#	print 'Recent fbr: {}'.format(fbr);
	#	print 'foundl={}, foundl2={}, start={}, foundr={}, rec_back={}.'.format(foundl, foundl2, start, foundr, rec_back);
		if (0 < foundl2 and foundl2 < foundr):
			recursion.append(foundl);
			ftypes.append(ftype);
			fbrs.append(fbr);
			start = foundl2;
			rec_back = 0;
			continue;
		if (foundr == -1) : break;
		inbetween = text[foundl+3+len(ftype):foundr];
	#	print 'Gefunden:     "{}" mit Argumenten "{}" bei {}.'.format(ftype, inbetween, foundl);
	
		# Definition von inhaltsitems:
		# [0]: Rekursion (0 = normal, 1 = 1. Unter-Rekursion, 2 = 2. Unter-Rekursion, ...)
		# [1]: Marker-Typ (bisher: PAGE, SET, CHP)
		# [2]: Marker-Text
		# [3]: relativ: linke Stelle des Verweises (zeigt auf das erste #)
		# [4]: relativ: linke Stelle des Inhalts
		# [5]: relativ: rechte Stelle des Verweises (zeigt auf die schließende Klammer)
		# [6]: absolut: linke Stelle des Verweises (zeigt auf das erste #)
		# [7]: absolut: linke Stelle des Inhalts
		# [8]: absolut: rechte Stelle des Verweises (zeigt auf die schließende Klammer)
		rec_corr = 0;
		if (len(recursion)):
			rec_corr += recursion[len(recursion)-1] + 3 + len(ftypes[len(recursion)-1]);
		fields.append([len(recursion), ftype, inbetween, foundl - rec_corr, foundl - rec_corr+3+len(ftype), foundr - rec_corr, foundl, foundl+3+len(ftype), foundr]);
		start = foundr + 1;
		rec_back = 0;
	return fields
