#/usr/bin/env python
#-*- encoding:utf-8 -*-

# Aufrufen mit: execfile('Switch-Text.py');

# (c) Jonas Bechtel 2017


"""
gotoPage(4)
currentPage()
obj = 'SynReg'
selectObject('MarkSynReg')
selectObject(obj)
getAllText(obj)
selectText(210,5,obj)
getText(obj)
getFont(obj)
getGuiLanguage()
gotoPage(22)
currentPage()
getAllObjects()
getAllText('Tmagic_Dolor')
pobj = getAllObjects()
pobj[1].find('____f')
#linkTextFrames('Ta', 'Tb')
#linkTextFrames('Tb', 'Tc')
getLayers()
"a" == "b"
scribus.duplicateObject('Ta')"""


# Übernommen von Scribus-Inhalt.py, Version ~0.222

import re # For Eval of ##IF(++ELSE) and for finding marks from XML file.
import os # For system()
import subprocess; # For ##EXEC()

import scribus

layers = scribus.getLayers();
lnr = False;
lfu = False;
for i in range(1, len(layers)):
	if (layers[i] == 'L_noreach'):
		scribus.deleteLayer('L_noreach')
	elif (layers[i] == 'L_full'):
		scribus.deleteLayer('L_full')

scribus.createLayer('L_noreach');
scribus.createLayer('L_full');
#scribus.setLayerVisible('L_noreach', False);
#scribus.setLayerVisible('L_full', False);

f = open(path_name + 'Field-Compute.py'); exec(f.read()); f.close();
ALLOWED_FIELDS= ['PAGE', 'LATIN', 'ROMAN', 'CALC', 'CNT', 'CHP', 'MARK', 'IF', 'GET', 'SET', 'SETGET', 'PERSIST', 'DOCLINK', 'PAGEOF', 'EXEC', 'C', 'TOC'];

f = open(path_name + 'UTF-8-escape.py'); exec(f.read()); f.close();


DOCVAR_NOT_PERSISTENT = 0;
DOCVAR_PERSISTENT     = 1;

def get_var_index(docvars, varname):
	for i in range(len(docvars)):
		if (docvars[i][0] == varname):
			return i;
	return -1;

def get_var(docvars, varname):
	i = get_var_index(docvars, varname);
	if (i >= 0):
		return docvars[i][1];
	else:
		return [];

def set_var(docvars, varname, newval):
	i = get_var_index(docvars, varname);
	if (i >= 0):
		docvars[i][1] = str(newval);
	else:
		docvars
		docvars.append([varname, newval, DOCVAR_NOT_PERSISTENT]);
		# TODO: Check for duplicates!

def is_second_run(docvars):
	r = get_var(docvars, 'SECOND_RUN');
	if r == '1':
		return True;
	return False;

# Returns DOCVAR_PERSISTENT if the var exists and is persistent.
def is_persistent(docvars, varname):
	r = get_var_index(docvars, varname);
	if r >= 0:
		return docvars[r][2];
	return -1;
def set_persistent(docvars, varname, persistence):
	r = get_var_index(docvars, varname);
	if r >= 0:
		print (docvars)
		print (r)
		print (docvars[r]);
		if len(docvars[r]) > 2:
			docvars[r][2] = persistence;
		else:
			docvars[r].append(persistence);
		return True;
	return False;

def dump_vars(docvars):
	print ('Switch_Text: Dump of {} document variables.'.format(len(docvars)));
	
	for i in range(0, len(docvars)):
		pstr = ' ';
		if len(docvars[i]) > 2:
			if docvars[i][2] == DOCVAR_PERSISTENT:
				pstr = 'p';
		print ('           {}   {}={}.'.format(pstr, docvars[i][0], docvars[i][1]));


def myselect(fr, sz, objname):
#	print 'Selecting text from pos {}: {} chars.'.format(fr, sz);
	##scribus.selectText(fr-10, sz+20, objname);
	#t_wide = ''; #t_wide = scribus.getAllText(objname);
	if objname == []:
		scribus.selectText(fr, sz);
	else:
		scribus.selectText(fr, sz, objname);
#	if objname == []:
#		t_narrow = scribus.getAllText();
#	else:
#		t_narrow = scribus.getAllText(objname);
#	print '    -> selected: "{}"'.format(t_narrow);


def myselect2(fr, sz):
	myselect (fr, sz, []);


def handle_fields(docvars, objname):
	print (objname + '<-- handle_fields()');
	
	scribus.deselectAll();
	scribus.selectObject(objname);
	ESCAPE=0;
	if o_utf_check_16bit_constraint(lvl=4) == 0:
		o_utf_escape(objname, 4);
		ESCAPE=1;
		
	
	#dump_vars(docvars);
	path_name = re.sub(r'[^/]+$', '', scribus.getDocName()); # for ##EXEC()
	
	# To see how Microsoft does make it:
	# http://www.addbalance.com/usersguide/fields.htm
	# https://support.office.com/en-us/article/Field-codes-PageRef-field-bbda448f-7233-4aaa-b061-55ca4664c4d7?ui=en-US&rs=en-US&ad=US
	
	
	
	scribus.deselectAll();
	scribus.selectObject(objname);
	# Problem: getText könnte auch nur die Auswahl zurückgeben.
	text = scribus.getAllText();# objname);
	fields = getFields(text, ALLOWED_FIELDS);
	print (fields);
	# In fieldbias wird für jedes Feld eingetragen, wie viele Zeichen
	# dazugekommen sind (positiv) oder gelöscht wurden (negativ). Die
	# Feldauszueichnung selbst ("##XYZ()") wird i. d. R. gelöscht, es
	# wird also fieldbias häufig negativ sein.
	# Die Eintragung ist nicht-rekursiv, d. h. hier wird nur das
	# angegeben, was tatsächlich bei der Bearbeitung des Feldes selbst
	# passiert, und nicht, was inklusive Unterfelder passiert.
	fieldbias = [-555];
	
	textbias = int(0);
	ref_db = [[]];
	
	for f in range(1, len(fields)):
		fieldbias.append(0);
		#print fieldbias
		print (fields[f]);
		old_size_of_subfields = 0;
		new_size_of_subfields = 0;
		actual_offset = 0;
		
		sres = 0;
		for s in range (f-1, 0, -1):
			if (fields[f][0] >= fields[s][0]):
				sres = s;
				break;
			#print '-> size: {}'.format(s);
			old_size_of_subfields += fields[s][8] + 1 - fields[s][6];
			new_size_of_subfields += fields[s][8] + 1 - fields[s][6] + fieldbias[s];
		#print 'sres={}'.format(sres);
		for s in range (sres, 0, -1):
			#print '-> offset: {}'.format(s);
			actual_offset += fieldbias[s];
			
		#print 'actual_offset = {}'.format(actual_offset);
		
		field_bias = new_size_of_subfields-old_size_of_subfields;
		
		#  Cann't operation on old text not recommended; have to load new one:
		complete_content_size = fields[f][8]-fields[f][7]+field_bias;
		if (complete_content_size == 0):
			text = '';
		else:
			myselect2(fields[f][7] + actual_offset, complete_content_size);# , objname);
			text = scribus.getAllText(); #objname);
		
		
		# Processing the individual fields:
		
		# Field: PAGE
		# output: the linear page number (= pdf page number)
		# Arguments: none
		# Remark: only use ##PAGE() if all text frames are on the same page!
		# Status: working + TODO: allow argument ("lfd") which includes the
		#			displayed page number instead of the pdf page number
		#			(see TODO pagetable in final_PDF())
		if (fields[f][1] == 'PAGE'):
			output = str(scribus.currentPage());
			
			scribus.insertText(output, fields[f][8]+1 + actual_offset + field_bias);# , objname);
			
			delsize = fields[f][8] - fields[f][6] + 1 + field_bias;
			myselect2(fields[f][6] + actual_offset, delsize);# , objname);
			scribus.deleteText(); # Delete ##PAGE() and even the useless stuff in the brackets.
			
			fieldbias[f] = len(output) - delsize;
		
		# Field: LATIN
		# output: a upper case latin letter (or more)
		# Argument: positive number
		# Remark: A=1 Z=26 AA=27 AZ=52 BA=53 BZ=78 ZZ=702
		#		(so the least significant letter is shifted.)
		# Status: working
		if (fields[f][1] == 'LATIN'):
			LAT_str = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
			num = int(text);
			
			digit_count = 1;
			cmpval = 26;
			cmpsum = 0;
			while True:
				if (num-1 < cmpval):
					break;
				num -= cmpval;
				cmpsum += cmpval;
				cmpval *= 26;
				digit_count += 1;
			
			num += cmpsum; # Restore old value.
			output = ''
			for d in range (1, digit_count):
				cmpval = cmpval/26;
				tmp = (num-1)/cmpsum;
				#print tmp
				output += ('*' + LAT_str)[tmp];
				num -= tmp*cmpval;
				cmpsum -= cmpval;
			output += ('*' + LAT_str)[num];
			
			scribus.insertText(output, fields[f][8]+1 + actual_offset + field_bias);# , objname);
			
			delsize = fields[f][8] - fields[f][6] + 1 + field_bias;
			myselect2(fields[f][6] + actual_offset, delsize);# , objname);
			t = scribus.getAllText();
			#print 'T: ' + t + '   <- ' + str(digit_count) + ' digits -> bias {}.'.format(digit_count - delsize);
			scribus.deleteText(); # Delete all ##LATIN(*)
			
			fieldbias[f] = digit_count - delsize;
			
		
		# Field: ROMAN
		# output: a upper case roman number
		# Argument: positive number
		# Status: working
		# Remark: [SEO: ##ROMAN]
		if (fields[f][1] == 'ROMAN'):
			ROMAN_hardcoded = ['O', 'I', 'II', 'III', 'IV', 'V', 'VI', 'VII', 'VIII', 'IX', 'X'];
			ROMAN_hardcoded += ['XI', 'XII', 'XIII', 'XIV', 'XV'];
			num = int(text);
			
			output = ROMAN_hardcoded[num];
			
			scribus.insertText(output, fields[f][8]+1 + actual_offset + field_bias);# , objname);
			
			delsize = fields[f][8] - fields[f][6] + 1 + field_bias;
			myselect2(fields[f][6] + actual_offset, delsize);# , objname);
			t = scribus.getAllText();
			#print 'T: ' + t + '   <- ' + str(digit_count) + ' digits -> bias {}.'.format(len(output) - delsize);
			scribus.deleteText(); # Delete all ##ROMAN(*)
			
			fieldbias[f] = len(output) - delsize;
			
		
		# Field: CALC
		# Evaluates the value given and stores it to the variable.
		# output: nothing (deleted completely)
		# Status: working
		elif (fields[f][1] == 'CALC'):
			
			shorted = re.sub(r"[0-9=+\-*/.() ]", '', text);
			#print shorted
			if (len(shorted)):
				print ('Switch_Text:handle_fields():IF: ERROR: condition may only contain a small set')
				print ('Switch_Text:handle_fields():IF:         of characters!.')
				continue;
			
			# Clean the non-right statement and the if clause itself.
			output = str(eval(text));
			
			scribus.insertText(output, fields[f][8]+1 + actual_offset + field_bias);# , objname);
			
			#print [fields[f][6], actual_offset, fields[f][8], field_bias]
			delsize = fields[f][8]+1 - fields[f][6] + field_bias;
			myselect2(fields[f][6] + actual_offset, delsize);# , objname);
			scribus.deleteText(); # Delete all ##CALC(*)
			
			fieldbias[f] = len(output) - delsize;
			
		
		# Field: CNT
		# (##CNT)
		# output: nothing (deleted completely)
		# Status: working + Recursion: OK
		elif (fields[f][1] == 'CNT'):
			# Parse fields
			blankpos = text.find(' ', 0);
			if (blankpos == -1):
				blankpos = len(text);
				cntlvl = 1;
				cntvar = text;
			else:
				cntvar = text[0:blankpos];
				cntlvl = int(text[blankpos+1:]);
			if (len(cntvar) == 0):
				cntvar = 'chp';
			
			pre = '__cnt_' + cntvar + '_';
			# Count up
			lvl = get_var(docvars, pre + 'lvl');
			#print 'lvl={} (type {})'.format(lvl, type(lvl));
			if (lvl == []):
				lvl = 1;
				set_var(docvars, pre + 'lvl', 1);
				set_var(docvars, pre + 'at_1', 0);
			else:
				lvl = int(lvl);
			if (cntlvl > lvl):
				lvl = lvl + 1;
				lvl_varname = pre + 'at_' + str(lvl)
				set_var(docvars, pre + 'lvl', lvl);
				set_var(docvars, lvl_varname, str(1));
				if (cntlvl > lvl):
					print ('Switch_Text:handle_fields(): WARNING: Counter of level {} requested, but last level ({}) was too low!'.format(cntlvl, lvl));
			else:
				lvl = cntlvl;
				set_var(docvars, pre + 'lvl', lvl);
				lvl_varname = pre + 'at_' + str(lvl);
				cnt_recent = get_var(docvars, lvl_varname);
				cnt_recent
				set_var(docvars, lvl_varname, str(int(cnt_recent)+1));
			
			# Nun die ganze Kette
			cnt_str = get_var(docvars, pre + 'at_1');
			for l in range(2, lvl+1):
				#print l
				cnt_recent = get_var(docvars, pre  + 'at_' + str(l));
				#print ['cnt_recent:', cnt_recent];
				cnt_str = cnt_str + '.' + cnt_recent;
			
			set_var(docvars, pre + 'str', cnt_str);
			dump_vars(docvars);
			
			delsize = fields[f][8] - fields[f][6] + 1 + new_size_of_subfields - old_size_of_subfields;
			myselect2(fields[f][6] + actual_offset, delsize);# , objname);
			scribus.deleteText(); # CNT is invisible.
			fieldbias[f] = 0-delsize + old_size_of_subfields - new_size_of_subfields;
			
			
		# Field: CHP
		# output: title
		# Status: Recursion: OK, but function unfinished! -> TODO
		# Remark: [SEO: ##CHP]
		elif (fields[f][1] == 'CHP'):
			if (text[0:4] == 'toc '):
				st = 4;
				toc = True;
			elif (text[0:6] == 'notoc '):
				st = 6;
				toc = False;
			else:
				print ('Switch_Text:handle_fields(): ERROR: ##CHP({}) does not begin with toc/notoc!'.format(text));
				continue;
			
			chp_title = text[st:];
			
			cnt = get_var(docvars, '__cnt_chp_str');
			print ('FOUND: CHP toc?{}, cnt={}, title={}'.format(toc, cnt, chp_title));
			
			
			myselect2(fields[f][8] + actual_offset + new_size_of_subfields - old_size_of_subfields, 1);# , objname);
			scribus.deleteText(); # Delete bracket
			myselect2(fields[f][6] + actual_offset, fields[f][7] - fields[f][6] + st - 1 + 1);# , objname);
			scribus.deleteText(); # Delete Field command without blank (Update: with blank)
			
			# Taken and modified from ##MARK
			pos_left = fields[f][6] + actual_offset;
			pos_right = pos_left + complete_content_size - (st-1+1);
			print ([pos_left, pos_right]);
			scribus.insertText(' //CH {}//'.format(cnt), pos_right);# , objname);
			myselect2(pos_right+1, 7+len(cnt));# , objname);
			scribus.setTextColor('White');# , objname);
			# Don't insert number at all as the user may want to decide whether to use ist.
			## insert left after right as the position pos_left would be 
			#scribus.insertText(cnt, pos_left, objname); # wrong otherwise.
			
			fieldbias[f] = 8 + len(cnt) - 7 - (st-1+1);
			
			toc_cnt = str(int(get_var(docvars, '__toc_cnt_toc')) + 1);
			set_var(docvars, '__toc_name_' + toc_cnt + '_toc', chp_title);
			set_var(docvars, '__toc_mark_' + toc_cnt + '_toc', 'CH ' + cnt);
			set_var(docvars, '__toc_lvl_'  + toc_cnt + '_toc', get_var(docvars, '__cnt_chp_lvl'));
			set_var(docvars, '__toc_cnt_toc', toc_cnt);
			
			# TODO: Save title text! (in case of 'toc')
			#TODO - register chapter to toc
			
		# Field: MARK
		# output: Content of MARK with two white slashes added before and after it.
		# Remark: Please do use the same font and font size for '##MARK(' as for the complete content.
		# Status: working + Recursion: OK
		elif (fields[f][1] == 'MARK'):
			myselect2(fields[f][8] + actual_offset + new_size_of_subfields - old_size_of_subfields, 1);# , objname);
			scribus.deleteText();
			myselect2(fields[f][6] + actual_offset, fields[f][7] - fields[f][6]);# , objname);
			scribus.deleteText();
			
			pos_left = fields[f][6] + actual_offset;
			pos_right = pos_left + complete_content_size;
			myselect2(pos_left, complete_content_size);
			marktext = scribus.getAllText();
			print ([pos_left, pos_right, marktext]);
			scribus.insertText('//', pos_left);# , objname);
			pos_right += 2;
			scribus.insertText('//', pos_right);
			myselect2(pos_left, 2);# , objname);
			#scribus.setTextColor('Red', objname);
			scribus.setTextColor('White');# , objname);
			#scribus.setFontSize(2, objname); # Destroys word glue between // and content.
			myselect2(pos_right, 2);# , objname);
			#scribus.setTextColor('Red', objname);
			scribus.setTextColor('White');# , objname);
			#scribus.setFontSize(2, objname); # Destroys word glue between // and content.
			
			
			# TODO: Save title text! (in case of 'toc')
			fieldbias[f] = 4 - 1 - (fields[f][7] - fields[f][6]);
			
			
			mark_cnt = str(int(get_var(docvars, '__mark_cnt')) + 1);
			set_var(docvars, '__mark_' + mark_cnt, marktext);
			
			
		# Field: IF
		# output: nothing (deleted completely) or text before ++ELSE of text after ++ELSE
		# TODO: Description
		# Status: working + Recursion: OK
		elif (fields[f][1] == 'IF'):
			# Parse fields
			
			#text
			#print '##IF: Text={}.'.format(text);
			take_text=[-1, -1];
			alternative_text=[-1, -1];
			
			blankpos = text.find(' ', 0);
			blankpos2 = text.find('\r', 0);
			print ([blankpos, blankpos2]);
			if (-1 < blankpos2 and blankpos2 < blankpos):
				blankpos = blankpos2;
			if (blankpos == -1):
				print ('Switch_Text:handle_fields():IF: ERROR: if clause not complete.')
				print ('Switch_Text:handle_fields():IF: Usage: ##IF(condition content1 ++ELSE content2).')
				continue;
			else:
				condition = text[0:blankpos];
				take_text = [blankpos + 1, -1];
			
			elsepos = text.find('++ELSE', take_text[0]);
			if (elsepos == -1):
				take_text = [take_text[0], len(text)];
			else:
				greedy_else = 0;
				if (text[elsepos-1:elsepos] == ' ' or text[elsepos-1:elsepos] == '\r'):
					greedy_else = 1;
				take_text = [take_text[0], elsepos - greedy_else];
				
				greedy_else2 = 0;
				if (text[elsepos+6:elsepos+7] == ' ' or text[elsepos+6:elsepos+7] == '\r'):
					greedy_else2 = 1;
				alternative_text = [elsepos+6+greedy_else2, len(text)];
			
			
			# Eval
			shorted = re.sub(r"'[^\\']*'", '', condition)
			shorted = re.sub(r"[0-9=+\-*/'.() ]", '', shorted);
			#print shorted
			if (len(shorted)):
				print ('Switch_Text:handle_fields():IF: ERROR: condition may only contain a small set')
				print ('Switch_Text:handle_fields():IF:         of characters!.')
				continue;
			
			# print '##IF: Condition = {}'.format(condition);
			if (eval(condition)):
				# Clean the non-right statement and the if clause itself.
				#  -  "##IF(condition " and " ++ELSE content2)"
				delsize1 = 5 + len(condition) + 1
				myselect2(fields[f][6] + actual_offset, delsize1);# , objname);
				#print scribus.getAllText(objname);
				scribus.deleteText();
				fieldbias[f] -= delsize1;
				#print 'TRUE.    {} -> {}'.format(take_text[0], take_text[1]);
				if_content1_size = take_text[1] - take_text[0];
				delsize2 = len(text)+1 -take_text[1];
				print ([len(text), 1, delsize1, take_text[1]]);
				myselect2(fields[f][7]+actual_offset-5 + if_content1_size, delsize2);# , objname);
				#print scribus.getAllText(objname);
				scribus.deleteText();
				fieldbias[f] -= delsize2;
				
			else:
				if (alternative_text[0] == -1):
					# Clean everything.
					lbias = 0;
					for fx in range(1, len(fields)):
						if fields[fx][6] < fields[f][6]:
							continue;
						if fields[fx][8] > fields[f][8]:
							break;
						lbias += fieldbias[fx];
					delsize = fields[f][8]+1-fields[f][6] + lbias;
					myselect2(fields[f][6]+actual_offset, delsize);# , objname);
					scribus.deleteText();
					fieldbias[f] -= delsize;
				else:
					# Clean "##IF(condition content1 ++ELSE " and ")"
					
					#print 'FALSE.   {} -> {}'.format(alternative_text[0], alternative_text[1]);
					
					delsize2 = 1;
					myselect2(fields[f][8]+actual_offset+field_bias, delsize2);# , objname);
					#print scribus.getAllText(objname);
					scribus.deleteText();
					fieldbias[f] -= delsize2;
					
					# lbias ist gar nicht nötig ...
				#	lbias = 0;
				#	for fx in range(1, len(fields)):
				#		if fields[fx][6] < fields[f][6]:
				#			continue;
				#		if fields[fx][8] > fields[f][7]+alternative_text[0]:
				#			break;
				#		lbias += fieldbias[fx];
				#	
				#	print [lbias];
					lbias = 0;
					delsize1 = 5 + alternative_text[0] + lbias;
					myselect2(fields[f][6]+actual_offset, delsize1);# , objname);
					print (scribus.getAllText());# objname);
					scribus.deleteText();
					fieldbias[f] -= delsize1;
					
		# Field: GET
		# output: nothing (deleted completely)
		# Status: working
		# Remark: [SEO: ##GET]
		elif(fields[f][1] == 'GET'):
			newtext = get_var(docvars, text);
			if newtext == []:
				print ('Switch_Text:handle_fields():GET: ERROR: coudln\'t find')
				print ('Switch_Text:handle_fields():GET:         variable {}!.'.format(text));
				continue;
				
			scribus.insertText(newtext, fields[f][8]+field_bias+actual_offset);# , objname);
			myselect2(fields[f][8]+actual_offset+field_bias+len(newtext), 1);# , objname);
			#print scribus.getAllText(objname);
			scribus.deleteText();# objname);
			myselect2(fields[f][6]+actual_offset, 6+complete_content_size);# , objname);
			#print scribus.getAllText(objname);
			scribus.deleteText();# objname);
			fieldbias[f] -= 6+complete_content_size+1;
			fieldbias[f] += len(newtext);
			
		
		
		# Field: SET
		# ##SET
		# output: nothing (deleted completely)
		# Status: working
		elif (fields[f][1] == 'SET'):
			
			# Parse fields
			blankpos = text.find(' ', 0);
			if (blankpos == -1):
				varname = text;
				content = '';
			else:
				varname = text[0:blankpos];
				content = text[blankpos+1:];
			
			set_var(docvars, varname, content);
			dump_vars(docvars);
			
			
			delsize = fields[f][8] - fields[f][6] + 1 + new_size_of_subfields - old_size_of_subfields;
			myselect2(fields[f][6] + actual_offset, delsize);# , objname);
			scribus.deleteText(); # SET is invisible.
			fieldbias[f] = 0-delsize;
		
		
		# Field: SETGET
		# output: content of the future variable.
		# Status: TODO: Test
		# Remark: [SEO: ##SETGET]
		elif(fields[f][1] == 'SETGET'):
			
			
			# Parse fields
			blankpos = text.find(' ', 0);
			if (blankpos == -1):
				varname = text;
				content = '';
			else:
				varname = text[0:blankpos];
				content = text[blankpos+1:];
			
			set_var(docvars, varname, content);
			dump_vars(docvars);
			
			
			delsize = fields[f][7] - fields[f][6] + blankpos + 1;
			myselect2(fields[f][6] + actual_offset, delsize);
			scribus.deleteText(); # First part "##SETGET(varname ".
			
			# Second part "varcontent" is kept.
			
			myselect2(fields[f][8] + actual_offset + field_bias - delsize, 1);
			scribus.deleteText(); # Third part ")".
			
			fieldbias[f] = 0-delsize-1;
		
		
		# Field: PERSIST
		# output: nothing (deleted completely)
		# Status: TODO: Test
		# Remark: [SEO: ##PERSIST]
		elif(fields[f][1] == 'PERSIST'):
			
			
			# Parse fields
			blankpos = text.find(' ', 0);
			if (blankpos == -1):
				varname = text;
				content = DOCVAR_PERSISTENT;
			else:
				varname = text[0:blankpos];
				content = text[blankpos+1:];
	#			print text
	#		print blankpos;
			set_persistent(docvars, varname, int(content));
			dump_vars(docvars);
			
			
			delsize = fields[f][8] - fields[f][6] + 1 + new_size_of_subfields - old_size_of_subfields;
			myselect2(fields[f][6] + actual_offset, delsize);# , objname);
			scribus.deleteText(); # PERSIST is invisible.
			fieldbias[f] = 0-delsize;
		
		
		
		# Field: PAGEOF
		# arguments: ##PAGEOF(<value1> <type> <object/mark>)
		# output:
		#    1st run: value1 (um das Problem der Selbstbeeinflussung zu verhindern.)
		#    2nd run: actual page number (style like the last character of
		#         value1, padded by white leading zeros to the length of value1)
		# type = 'Object' E.g.: This image can be found at page ##PAGEOF(Object Beautiful_imported_image_3)
		# type = 'Mark'. E.g.: ##MARK(blabla) ... see page ##PAGEOF(Mark blabla)
		# Status: TODO
		elif (fields[f][1] == 'PAGEOF'):
			
			'TODO: implement ##PAGEOF()!'
		
		# Field: DOCLINK
		# usage: ##DOCLINK([P=<at/from>[..<to>]]] <type_src> <object_srv/mark_srv>++++[P=<from>[..<to>]]] <type_tgt> <object_tgt/mark_tgt>)
		# output: nothing (deleted completely)
		# Example: You can find that data plotted ##MARK(here). ##DOCLINK(Mark here++++Object Diagram_power_w_green)
		# Remark: Keep in mind that the Mark content has to be unique over the
		#    whole document. So the example is a rather bad example.
		# Example: ##MARK(here) ##DOCLINK(P=##GET(plot_descr_begin)..##PAGEOF(Object Last_Diagram) Mark here+++Object Diagram_power_w_green)
		# Future Dream: P=linked <- automatically searches on only thoes pages where a linked text frame of this text exists.
		# Status: TODO
		elif (fields[f][1] == 'DOCLINK'):
			m = re.match('(P=[0-9]+[.0-9]*|) ?(Mark|Object) (.*)[+][+][+][+](P=[0-9]+[.0-9]*|) ?(Mark|Object) (.*)', text);
			if (type(m) == 'NoneType'):
				print ('Switch_Text:handle_fields(): ERROR: ##DOCLINK field not parsable. Leaving it untouched.')
				continue;
			
			delsize = 10+complete_content_size+1;
			myselect2(fields[f][6]+actual_offset, delsize);# , objname)
			scribus.deleteText();# objname);
			fieldbias[f] = 0-delsize;
			
			if (get_var(docvars, 'SECOND_RUN')=='1'):
				continue;
			
			psrc = m.groups()[0];
			tsrc = m.groups()[1];
			dsrc = m.groups()[2];
			ptgt = m.groups()[3];
			ttgt = m.groups()[4];
			dtgt = m.groups()[5];
			
			if (tsrc == 'Object' or ttgt == 'Object'):
				print ('##DOCLINK: TODO/ERROR: Object unsupported yet :-(')
				continue;
			if (len(psrc)+len(ptgt) > 0):
				print ('##DOCLINK: TODO/WARNING: Page pre-selection unsupported yet :-(')
			
			if (tsrc == 'Mark'):
				0
				# Game over ... There's no scribus function to set annotation targets.
				#		Even with scribus.getProperty it's not possible.
				# Game over? No! We can cheat and edit the .sla file directly!
				# So this is a first run only action.
				# TODO: Set a ref_db remark which will be read and laid out in between 
				# The two runs.
			else:
				print ('##DOCLINK: ERROR: Cann\'t handle source type {}.'.format(tsrc));
				continue;
			if (ttgt == 'Mark'):
				0
			else:
				print ('##DOCLINK: ERROR: Cann\'t handle target type {}.'.format(ttgt));
				continue;
			'TODO: ##DOCLINK'
			
		
		# Field: EXEC
		# arguments: ##EXEC(<command>)
		# output: stdout and stderr of <command>. Please note that the command
		#    is called twice (once in 1st run and once in 2nd run)
		# Remark: I recommend to delete the trailing newline as otherwise it
		#    will cause the separation into a new paragraph.
		# Status: TODO
		elif (fields[f][1] == 'EXEC'):
			# https://stackoverflow.com/questions/4760215/running-shell-command-from-python-and-capturing-the-output
			# -> Answer https://stackoverflow.com/questions/4760215/running-shell-command-from-python-and-capturing-the-output/4760517#4760517
			
			old_path = os.getcwd();
			os.chdir(path_name)
			newtext = subprocess.check_output(['sh', '-c', '(' + text + ') 2>&1; true']);
			assert(utf_check_16bit_constraint(newtext));
			newtext = newtext.decode('utf-8');
			os.chdir(old_path);
			
			scribus.insertText(newtext, fields[f][8]+1 + actual_offset + field_bias);# , objname);
			
			#print [fields[f][6], actual_offset, fields[f][8], field_bias]
			delsize = fields[f][8]+1 - fields[f][6] + field_bias;
			myselect2(fields[f][6] + actual_offset, delsize);# , objname);
			scribus.deleteText(); # Delete all ##CALC(*)
			
			fieldbias[f] = len(newtext) - delsize;
			
			#WEERRRR - TODO!
			
		# Field: C (comment)
		# output: nothing (deleted completely)
		# Remark: ##C{blab} is the same as ##C(blab) is the same as ##IF(0 blab)
		# Status: TODO: test
		elif (fields[f][1] == 'C'):
			
			delsize = fields[f][8]+1 - fields[f][6] + field_bias;
			myselect2(fields[f][6] + actual_offset, delsize);# , objname);
			scribus.deleteText();
			fieldbias[f] = 0-delsize;
			
		# Field: TOC  (Table of content)
		# Remark: [SEO: ##TOC]
		elif fields[f][1] == 'TOC':
			tocseries = text;
			if len(tocseries) == 0:
				# Assuming toc
				tocseries = 'toc'
			
			toc_cnt = get_var(docvars, '__toc_cnt_' + tocseries);
			if toc_cnt == []:
				print ('Switch_Text:handle_fields():TOC: ERROR: coudln\'t find one toc')
				print ('Switch_Text:handle_fields():TOC:         entry (series {})!.'.format(tocseries));
				continue;
			
			addsize = 0;
			i = 0;
			while i < int(toc_cnt):
				i = i + 1;
				toc_name = get_var(docvars, '__toc_name_' + str(i) + '_' + tocseries);
				toc_mark = get_var(docvars, '__toc_mark_' + str(i) + '_' + tocseries);
				toc_lvl  = get_var(docvars, '__toc_lvl_'  + str(i) + '_' + tocseries);
					# (We don't need mark by now, but when the document links begin to work.)
				# TODO: Read TOC marks from intermediate pdf!
				
				# TODO: Recursion is needed here when page numbers are to be
				#		clickable!
				#	(or, we make the CH x.y.z notation clickable which
				#	 automatically applies to the page numbers then)
				toc_page = 'XXX';
				if is_second_run(docvars):
					toc_page = get_var(docvars, '__toc_page_' + str(i) + '_toc');
					if toc_page == []:
						toc_page = 'UNKOWN! (' + toc_mark + ')';
					toc_page_o = get_var(docvars, 'p_official_' + str(toc_page));
					if toc_page_o == []:
						toc_page_o = '_' + str(toc_page);
					print('  found page "{}" -> official "{}".'.format(toc_page, toc_page_o));
					newtext = toc_name + ' \t ' + str(toc_page_o) + '\r';
				else:
					newtext = toc_name + ' \t ' + toc_mark + '\r';
					
				print ([toc_name, toc_mark, toc_page]);
				
				scribus.insertText(newtext, fields[f][8]+field_bias+actual_offset+addsize);# , objname);
				add_size = len(newtext);
				scribus.deselectAll();
				myselect(fields[f][8]+field_bias+actual_offset+addsize, add_size, objname);
				scribus.setStyle('Im_Inhaltsverzeichnis_' + str(toc_lvl), objname);
				scribus.deselectAll();
				scribus.selectObject(objname);
				addsize = addsize + add_size;
				
			
			myselect2(fields[f][8]+actual_offset+field_bias+addsize, 1);# , objname);
			#print scribus.getAllText(objname);
			scribus.deleteText();# objname);
			myselect2(fields[f][6]+actual_offset, 6+complete_content_size);# , objname);
			#print scribus.getAllText(objname);
			scribus.deleteText();# objname);
			fieldbias[f] -= 6+complete_content_size+1;
			fieldbias[f] += addsize;
	
	if ESCAPE:
		o_back_to_utf(objname, 4);


VARIANT_FULL = 0;
VARIANT_NOREACH = 1;

# Einmal alles parsen ...
def switch_text(variant, extra_vars):
	
	if (variant == VARIANT_NOREACH):
		target_layer = 'L_noreach';
		docvars = [["VARIANT", "noreach"]];
	else: # assuming variant == VARIANT_FULL
		target_layer = 'L_full';
		docvars = [["VARIANT", "full"]];
	
	if (len(extra_vars) > 0):
		docvars = docvars + extra_vars;
	docvars.append(['PAGECOUNT', str(scribus.pageCount())]);
	docvars.append(['__toc_cnt_toc', 0]);
	docvars.append(['__mark_cnt', 0]);
	
	print (['is_second_run?', is_second_run(docvars)]);
	
	lcollect = [[0]];
	for page in range (1, scribus.pageCount()+1):
	#	print 'Seite {} ...'.format(page);
		scribus.gotoPage(page);
		#scribus.setActiveLayer('Hintergrund')
		pobj = scribus.getAllObjects();
#		for x in range(1, len(inhaltsitems)):
#			if inhaltsitems[x][3] >= 0 : continue;
#			for o in range (0, len(pobj)):
#				if pobj[o] == inhaltsitems[x][0] :
#					inhaltsitems[x][3] = page;
		
		# Alle infragekommenden Textframes sammeln und in die entsprechenden
		# Ebenen kopieren.
		for o in range (0, len(pobj)):
			if (pobj[o].find('Tmagic_') != 0): continue;
			extrapos = pobj[o].find('____f');
			linkorder = -1;
			if (extrapos == -1):
				basename = pobj[o][7:];
				name = basename
			else:
				basename = pobj[o][7:extrapos];
				name = pobj[o][7:];
				extrapos += 5;
				linkorder = int(pobj[o][extrapos:]);
			
			# Trying different languages for when people from different nations
			# work together and one of them has already invoked WiScri.
			new_name = 'TCmagic_' + name;
			if (scribus.objectExists(new_name)):
				scribus.deleteObject(new_name);
			
			new_name_check = scribus.duplicateObject(new_name, pobj[o]);
			assert(new_name == new_name_check);
			scribus.sentToLayer(target_layer, new_name);
			
			print ('Handling fields for Object ' + pobj[o] + ' ...')
			
			# Inserting and removing a newline will settle fonts
			#   (only needed one time after copying.)
			#   (This has been moved to UTF-8-escape.py)
			#scribus.insertText('X\rY', 0, new_name);
			#scribus.selectText(0,3,new_name)
			#scribus.deleteText(new_name)
			
			if (linkorder > 0):
				lcollect.append(['TCmagic_' + basename + '____f' + str(linkorder - 1), new_name]);
			else:
				#o_utf_escape(new_name); # in handle_fields
				handle_fields(docvars, new_name);
			
		
		print ('Seite {} fertig.'.format(page));
	
	l = 0;
	for l in range(1, len(lcollect)):
		scribus.linkTextFrames(lcollect[l][0], lcollect[l][1]);
	
	print ('lcollect: {} text frame linking actions.'.format(l));
	
	scribus.setLayerPrintable(target_layer, True);
	
	return docvars;
#


def prepare_marks(pagemarks, pdfname):
	path_name = re.sub(r'[^/]+$', '', scribus.getDocName());
#	pdfname = path_name + 'tmp_markpos.pdf';
#	p = scribus.PDFfile();
#	p.file = pdfname;
#	p.pages = range(1, scribus.pageCount()+1);
#	#p.save();
#	p = []; # Otherwise we get strange errors on future calls to 'string'.format()
#		# TODO: Hm; for some documents theses errors come even if p = [].
	
	# Tool aufrufen:
	# mit os.system() oder subprocess.call; siehe auch: raw strings: r'blabla'
	# siehe https://stackoverflow.com/questions/204017/how-do-i-execute-a-program-from-python-os-system-fails-due-to-spaces-in-path
	#
	##scribus.statusMessage('Converting pdf file to txt/xml');
	##scribus.messagebarText("ASDf");
	os.system("pdftotext -bbox " + pdfname + ' ' + path_name + 'tmp_markpos.xml');
	##scribus.statusMessage('');
	fd = os.open(path_name + 'tmp_markpos.xml', os.O_RDONLY);
	buf = b'';
	while True:
		plus_str = os.read(fd, 1024);
		buf = buf + plus_str;
		#print '...{}...'.format(len(buf));
		if (len(plus_str) != 1024):
			break;
	#print 'Switch_Text: read {} bytes from xml file.'.format(3);
	print (len(buf))
	print ('Switch_Text: prepare_marks(): read {} bytes from xml file.'.format(len(buf)));
	
	found = -1;
	while True:
		found = buf.find(b'<page ', found+1);
		#print found;
		if (found > -1):
			pagemarks.append(found);
		else:
			break;
	
	return buf;

def find_mark_simple(buf, pagemarks, mark):
	blanks = re.sub(b'[^ \t]', b'', mark);
	blankcount = len(blanks);
	if (blankcount == 0):
		return find_mark(buf, pagemarks, mark, 0, 'xx');
	else:
		m = re.search(b'^[^ ]+', mark);
		mleft = mark[m.start():m.end()];
		m = re.search(b'[^ ]+$', mark);
		mright = mark[m.start():m.end()];
		
		return find_mark(buf, pagemarks, mleft, blankcount, mright);

# Keep in mind: mark will act as regex string!
# componenttype: 0 = single, 1 = right (if second word = last word), 2 = right (if third word = last word)
def find_mark(buf, pagemarks, mark_left_or_single, componenttype, mark_right):
	
	if (componenttype == -1):
		mark_left_or_single = b'//' + mark_left_or_single + b'//';
	elif (componenttype >= 0):
		mark_left_or_single = b'//' + mark_left_or_single;
		mark_right = mark_right + b'//';
	
	generic_search_begin = b'<word xMin="([0-9.]+)" yMin="([0-9.]+)" xMax="([0-9.]+)" yMax="([0-9.]+)">';
	# Search...
	m = None;
	#print mark_right;
	m = re.search(b'[ ]+'+generic_search_begin+b'.*'+mark_left_or_single+b'</word>', buf);
	if m == None:
		print ('Switch_Text.py: find_mark(): ACHTUNG: Mark //"{}"... nicht gefunden!'.format(mark_left_or_single))
		return [[-1]];
	#print [' [L ' , m.start(0)];
	#print ['  L] ', m.end(0)];
	
	page = 0;
	for i in range(0, len(pagemarks)):
		if (pagemarks[i] > m.start(0)):
			break;
		page = i;
	
	ml = m;
	#print left_groups;
	# ('165.846930', '281.371440', '181.878930', '294.331440')
	# Yeah! Nearly done!
	
	if (componenttype == -1):
		return left_groups;
	
	offset = m.end(0);
	tmp_buf = buf[m.end(0):];
	
	for i in range(0, componenttype):
		offplus = buf.find(b'<word ', offset);
		#m = re.search('<word ', tmp_buf);
		##print m.end(0); # e. g. 11, 94, 93, 93, ...
		#offset += m.end(0);
		if offplus == -1:
			return [[-1]];
		
		offset = offplus;
		#tmp_buf = tmp_buf[m.end(0):];
		##print re.sub('\r', '\n', tmp_buf[0:200]);
	
	#expected_start = buf.find('<word ', offset);
	#print offset
	tmp_buf = buf[offset:];
	
	m = re.search(generic_search_begin+mark_right+b'.*</word>', tmp_buf);
	if m == None:
		print ('Switch_Text.py: find_mark(): ACHTUNG: Mark "{} ... {}" nicht gefunden!'.format(mark_left_or_single, mark_right))
		return [[-1]];
	#print [' [R ' , m.start(0)];
	#print ['  R] ', m.end(0)];
	
	if (m.start(0) != 0):
		# Den linken Start gab es schonmal früher, aber er passt nicht zum
		# aktuell gesuchten Mark-Ende.
		# Deswegen vom Mark-Ende behutsame rückwärts-Schritte gehen.
		
		for i in range(0, componenttype):
			offplus = buf.rfind(b'<word ', 0, m.start(0) + offset);
			#print offplus;
			
			if offplus == -1:
				return [[-1]];
			
			offset = offplus;
		#offset = buf.rfind('<word ', 0, offset);
		tmp_buf = buf[offset:];
		
		# Entsprechend nochmal den linken Mark-Teil suchen
		ml = re.search(generic_search_begin+b'.*'+mark_left_or_single+b'</word>', tmp_buf);
		#if ml != None:
		#	print m.start();
		if ml == None or ml.start() != 0:
			print ('Switch_Text.py: find_mark(): ACHTUNG: Mark "{} ... {}" nicht gefunden!'.format(mark_left_or_single, mark_right))
			return [[-1]];
		#print [' [L ' , ml.start(0)];
		#print ['  L] ', ml.end(0)];
	else:
		offset = 0;
	
	page = 0;
	for i in range(0, len(pagemarks)):
		#print [pagemarks[i], i];
		if (pagemarks[i] > ml.start(0) + offset):
			#print 'pagemark {} is bigger ({}).'.format(i, pagemarks[i])
			break;
		page = i;
	
	left_groups = [[page, ml.groups()[0], ml.groups()[1], ml.groups()[2], ml.groups()[3]]];
	right_groups = [page, m.groups()[0], m.groups()[1], m.groups()[2], m.groups()[3]];
	left_groups.append(right_groups);
	return left_groups;



def final_PDF(variant, pdfname):
	if (pdfname == []):
		dir_and_basename = re.sub(r'(sla|sla.gz)$', '', scribus.getDocName());
		pdfname = dir_and_basename + 'pdf';
	
	
	start = 1;
	if (variant == VARIANT_NOREACH):
		start = 2; # TODO: File name -> Zellortung
	
	# TOC position
	tocrange_from = re.sub(r'[a-z_0-9=\n\r]*[\n\r]tocrange_from=', '', scribus.getAllText('TCmagic_TOCrange____f0'));
	tocrange_from = int(re.sub(r'[a-z_=\n\r][a-z_0-9=\n\r]*', '', tocrange_from));
	tocrange_to = re.sub(r'[a-z_0-9=\n\r]*[\n\r]tocrange_to=', '', scribus.getAllText('TCmagic_TOCrange____f0'));
	tocrange_to = int(re.sub(r'[a-z_=\n\r][a-z_0-9=\n\r]*', '', tocrange_to));
	
	tocinclude = re.sub(r'[a-z_0-9=\n\r]*[\n\r]tocinclude=', '', scribus.getAllText('TCmagic_TOCinclude____f0'));
	tocinclude = int(re.sub(r'[a-z_=\n\r][a-z_0-9=\n\r]*', '', tocinclude));
	
	print ('Switch_Text:final_PDF(): tocrange_from="{}"   tocrange_to="{}"'.format(tocrange_from, tocrange_to));
	print ('Switch_Text:final_PDF(): Exporting to file "{}"'.format(pdfname));
	
	# You must keep the p = scribus.PDFfile invokation and the p = [] deletion
	#  together. I further recommend not to perform string/pattern/print
	#  operations in between as there's a strange bug with errors you cann't
	#  debug very well.
	p = scribus.PDFfile();
	p.file = pdfname;
	if (tocinclude > 0):
		pagerange = \
			  list(range(start, tocinclude)) \
			+ list(range(tocrange_from,tocrange_to+1)) \
			+ list(range(tocinclude,tocrange_from)) \
			+ list(range(tocrange_to+1,scribus.pageCount()+1));
		# CAUTION! This doesn't work in normal scribus installations
		# You need to perform one of the following modifications:
		# EITHER:
		#	Modify SOURCE/scribus/plugins/scriptplugin/objpdffile.cpp
		#		Therein Function PDFfile_setpages
		#		Therein REMOVE the call to PyList_Sort(self->pages)
		# OR:
		#   Use Scribus version 1.5.4 or above
		# OR:
		#	Open scribus with gdb
		# 		In gdb: break PyList_Sort
		#		In scribus: Open Scripter Console, execute following:
		#			p = PDFfile()
		#			p.pages = [2,1,3]
		#			print p.pages
		#		Now scribus freezes
		#		In gdb: bt
		#						then press q -> you see:
		#			[...]
		# 			#1  0x00007fd737744fb8 in ?? () from /usr/lib64/scribus/plugins//libscriptplugin.so
		#			[...]
		#		In gdb: disassemble /r 0x00007eff9195ffb8-20,+40
		#		Watch out for the callq line like this: 0x00007eff9195ffb3:  e8 48 e1 fc ff  callq  0x7eff9192e100 <PyList_Sort@plt>
		#		Quit gdb in order to unfreeze scribus.
		#		In any hex editor:
		#			Open libscriptplugin.so
		#			Search for e8 48 e1 fc ff (or whatever stands before callq in your gdb view)
		#				(You will find several of theese phrases; the one with )
		#			Replace these five bytes by 90 90 90 90 90 (5x x86 NOP)
		#		Close Scribus
		#		Open Scribus
		#	
		#	
		#	To confirm that Source or Binary Modification was successfull, do the following:
		#		In scribus: Open Scripter Console, execute following:
		#			p = PDFfile()
		#			p.pages = [2,1,3]
		#			print p.pages
		#		-> You have to see [2,1,3]. If you see [1,2,3], the mod failed - you made something wrong.
		
	else:
		pagerange = range(start, scribus.pageCount()+1);
	p.pages = pagerange;
	print (p.pages)
	# TODO: pagetable hier anlegen, damit bei der Rückübersetzung der ##MARKs die richtige Seitennummer
	#	gewählt wird.
	
	p.version = 11;
		# There are no photos in the document, only drawings.
	p.compressmtd = 3; # 2 = zip, 3 = None
	#p.embedPDF = 1;
	p.save();
	p = []; # Otherwise we may get strange errors on future calls to 'string'.format()
	
	return pagerange;

def ref_db2vars(buf, pagemarks, ref_db):
	ref_vars = [];
	# TODO: Hier weiterarbeiten!
	return ref_vars;





# dir(scribus) ->
# 1.4.1:
#['%', 'ALIGN_BLOCK', 'ALIGN_CENTERED', 'ALIGN_FORCED', 'ALIGN_LEFT', 'ALIGN_RIGHT', 'BUTTON_ABORT', 'BUTTON_CANCEL', 'BUTTON_IGNORE', 'BUTTON_NO', 'BUTTON_NONE', 'BUTTON_OK', 'BUTTON_RETRY', 'BUTTON_YES', 'CAP_FLAT', 'CAP_ROUND', 'CAP_SQUARE', 'COLOR', 'COLOR_BURN', 'COLOR_DODGE', 'DARKEN', 'DIFFERENCE', 'EXCLUSION', 'FACINGPAGES', 'FILL_CROSSDIAGONALG', 'FILL_DIAGONALG', 'FILL_HORIZONTALG', 'FILL_NOG', 'FILL_RADIALG', 'FILL_VERTICALG', 'FIRSTPAGELEFT', 'FIRSTPAGERIGHT', 'HARD_LIGHT', 'HUE', 'ICON_CRITICAL', 'ICON_INFORMATION', 'ICON_NONE', 'ICON_WARNING', 'ImageExport', 'JOIN_BEVEL', 'JOIN_MITTER', 'JOIN_ROUND', 'LANDSCAPE', 'LIGHTEN', 'LINE_DASH', 'LINE_DASHDOT', 'LINE_DASHDOTDOT', 'LINE_DOT', 'LINE_SOLID', 'LUMINOSITY', 'MULTIPLY', 'NOFACINGPAGES', 'NORMAL', 'NameExistsError', 'NoDocOpenError', 'NoValidObjectError', 'NotFoundError', 'OVERLAY', 'PAGE_1', 'PAGE_2', 'PAGE_3', 'PAGE_4', 'PAPER_A0', 'PAPER_A1', 'PAPER_A2', 'PAPER_A3', 'PAPER_A4', 'PAPER_A5', 'PAPER_A6', 'PAPER_A7', 'PAPER_A8', 'PAPER_A9', 'PAPER_B0', 'PAPER_B1', 'PAPER_B10', 'PAPER_B2', 'PAPER_B3', 'PAPER_B4', 'PAPER_B5', 'PAPER_B6', 'PAPER_B7', 'PAPER_B8', 'PAPER_B9', 'PAPER_C5E', 'PAPER_COMM10E', 'PAPER_DLE', 'PAPER_EXECUTIVE', 'PAPER_FOLIO', 'PAPER_LEDGER', 'PAPER_LEGAL', 'PAPER_LETTER', 'PAPER_TABLOID', 'PDFfile', 'PORTRAIT', 'Printer', 'SATURATION', 'SCREEN', 'SOFT_LIGHT', 'ScribusException', 'UNIT_C', 'UNIT_CENTIMETRES', 'UNIT_CICERO', 'UNIT_CM', 'UNIT_IN', 'UNIT_INCHES', 'UNIT_MILLIMETERS', 'UNIT_MM', 'UNIT_P', 'UNIT_PICAS', 'UNIT_POINTS', 'UNIT_PT', 'WrongFrameTypeError', '__builtin__', '__doc__', '__name__', '__package__', '_bu', '_ia', 'c', 'changeColor', 'closeDoc', 'closeMasterPage', 'cm', 'createBezierLine', 'createCharStyle', 'createEllipse', 'createImage', 'createLayer', 'createLine', 'createMasterPage', 'createParagraphStyle', 'createPathText', 'createPolyLine', 'createPolygon', 'createRect', 'createText', 'currentPage', 'defineColor', 'dehyphenateText', 'deleteColor', 'deleteLayer', 'deleteMasterPage', 'deleteObject', 'deletePage', 'deleteText', 'deselectAll', 'docChanged', 'duplicateObject', 'editMasterPage', 'exceptions', 'fileDialog', 'fileQuit', 'getActiveLayer', 'getAllObjects', 'getAllStyles', 'getAllText', 'getColor', 'getColorAsRGB', 'getColorNames', 'getColumnGap', 'getColumns', 'getCornerRadius', 'getDocName', 'getFillBlendmode', 'getFillColor', 'getFillShade', 'getFillTransparency', 'getFont', 'getFontNames', 'getFontSize', 'getGuiLanguage', 'getHGuides', 'getImageFile', 'getImageScale', 'getLayerBlendmode', 'getLayerTransparency', 'getLayers', 'getLineBlendmode', 'getLineCap', 'getLineColor', 'getLineJoin', 'getLineShade', 'getLineSpacing', 'getLineStyle', 'getLineTransparency', 'getLineWidth', 'getObjectType', 'getPageItems', 'getPageMargins', 'getPageNMargins', 'getPageNSize', 'getPageSize', 'getPageType', 'getPosition', 'getProperty', 'getPropertyCType', 'getPropertyNames', 'getRotation', 'getSelectedObject', 'getSize', 'getText', 'getTextColor', 'getTextDistances', 'getTextLength', 'getTextLines', 'getTextShade', 'getUnit', 'getVGuides', 'getXFontNames', 'getval', 'gotoPage', 'groupObjects', 'haveDoc', 'hyphenateText', 'importPage', 'inch', 'insertText', 'isLayerFlow', 'isLayerLocked', 'isLayerOutlined', 'isLayerPrintable', 'isLayerVisible', 'isLocked', 'isPDFBookmark', 'isSpotColor', 'linkTextFrames', 'loadImage', 'loadStylesFromFile', 'lockObject', 'mainWindow', 'masterPageNames', 'messageBox', 'messagebarText', 'mm', 'moveObject', 'moveObjectAbs', 'moveSelectionToBack', 'moveSelectionToFront', 'newDoc', 'newDocDialog', 'newDocument', 'newPage', 'newStyleDialog', 'objectExists', 'openDoc', 'p', 'pageCount', 'pageDimension', 'placeEPS', 'placeODG', 'placeSVG', 'placeSXD', 'progressReset', 'progressSet', 'progressTotal', 'pt', 'qApp', 'redrawAll', 'renderFont', 'replaceColor', 'retval', 'rotateObject', 'rotateObjectAbs', 'saveDoc', 'saveDocAs', 'savePageAsEPS', 'scaleGroup', 'scaleImage', 'scribus_version', 'scribus_version_info', 'scrollDocument', 'selectObject', 'selectText', 'selectionCount', 'sentToLayer', 'setActiveLayer', 'setColumnGap', 'setColumns', 'setCornerRadius', 'setCursor', 'setDocType', 'setFillBlendmode', 'setFillColor', 'setFillShade', 'setFillTransparency', 'setFont', 'setFontSize', 'setGradientFill', 'setGradientStop', 'setHGuides', 'setImageOffset', 'setImageScale', 'setInfo', 'setLayerBlendmode', 'setLayerFlow', 'setLayerLocked', 'setLayerOutlined', 'setLayerPrintable', 'setLayerTransparency', 'setLayerVisible', 'setLineBlendmode', 'setLineCap', 'setLineColor', 'setLineJoin', 'setLineShade', 'setLineSpacing', 'setLineStyle', 'setLineTransparency', 'setLineWidth', 'setMargins', 'setMultiLine', 'setPDFBookmark', 'setProperty', 'setRedraw', 'setScaleImageToFrame', 'setSpotColor', 'setStyle', 'setText', 'setTextAlignment', 'setTextColor', 'setTextDistances', 'setTextScalingH', 'setTextScalingV', 'setTextShade', 'setTextStroke', 'setUnit', 'setVGuides', 'sizeObject', 'statusMessage', 'textFlowMode', 'textOverflows', 'traceText', 'unGroupObject', 'unlinkTextFrames', 'valueDialog', 'warnings', 'zoomDocument', '\xb0']
# 1.4.6: (+applyMasterPage() + setNewName())
#['%', 'ALIGN_BLOCK', 'ALIGN_CENTERED', 'ALIGN_FORCED', 'ALIGN_LEFT', 'ALIGN_RIGHT', 'BUTTON_ABORT', 'BUTTON_CANCEL', 'BUTTON_IGNORE', 'BUTTON_NO', 'BUTTON_NONE', 'BUTTON_OK', 'BUTTON_RETRY', 'BUTTON_YES', 'CAP_FLAT', 'CAP_ROUND', 'CAP_SQUARE', 'COLOR', 'COLOR_BURN', 'COLOR_DODGE', 'DARKEN', 'DIFFERENCE', 'EXCLUSION', 'FACINGPAGES', 'FILL_CROSSDIAGONALG', 'FILL_DIAGONALG', 'FILL_HORIZONTALG', 'FILL_NOG', 'FILL_RADIALG', 'FILL_VERTICALG', 'FIRSTPAGELEFT', 'FIRSTPAGERIGHT', 'HARD_LIGHT', 'HUE', 'ICON_CRITICAL', 'ICON_INFORMATION', 'ICON_NONE', 'ICON_WARNING', 'ImageExport', 'JOIN_BEVEL', 'JOIN_MITTER', 'JOIN_ROUND', 'LANDSCAPE', 'LIGHTEN', 'LINE_DASH', 'LINE_DASHDOT', 'LINE_DASHDOTDOT', 'LINE_DOT', 'LINE_SOLID', 'LUMINOSITY', 'MULTIPLY', 'NOFACINGPAGES', 'NORMAL', 'NameExistsError', 'NoDocOpenError', 'NoValidObjectError', 'NotFoundError', 'OVERLAY', 'PAGE_1', 'PAGE_2', 'PAGE_3', 'PAGE_4', 'PAPER_A0', 'PAPER_A1', 'PAPER_A2', 'PAPER_A3', 'PAPER_A4', 'PAPER_A5', 'PAPER_A6', 'PAPER_A7', 'PAPER_A8', 'PAPER_A9', 'PAPER_B0', 'PAPER_B1', 'PAPER_B10', 'PAPER_B2', 'PAPER_B3', 'PAPER_B4', 'PAPER_B5', 'PAPER_B6', 'PAPER_B7', 'PAPER_B8', 'PAPER_B9', 'PAPER_C5E', 'PAPER_COMM10E', 'PAPER_DLE', 'PAPER_EXECUTIVE', 'PAPER_FOLIO', 'PAPER_LEDGER', 'PAPER_LEGAL', 'PAPER_LETTER', 'PAPER_TABLOID', 'PDFfile', 'PORTRAIT', 'Printer', 'SATURATION', 'SCREEN', 'SOFT_LIGHT', 'ScribusException', 'UNIT_C', 'UNIT_CENTIMETRES', 'UNIT_CICERO', 'UNIT_CM', 'UNIT_IN', 'UNIT_INCHES', 'UNIT_MILLIMETERS', 'UNIT_MM', 'UNIT_P', 'UNIT_PICAS', 'UNIT_POINTS', 'UNIT_PT', 'WrongFrameTypeError', '__builtin__', '__doc__', '__name__', '__package__', '_bu', '_ia', 'applyMasterPage', 'c', 'changeColor', 'closeDoc', 'closeMasterPage', 'cm', 'createBezierLine', 'createCharStyle', 'createEllipse', 'createImage', 'createLayer', 'createLine', 'createMasterPage', 'createParagraphStyle', 'createPathText', 'createPolyLine', 'createPolygon', 'createRect', 'createText', 'currentPage', 'defineColor', 'dehyphenateText', 'deleteColor', 'deleteLayer', 'deleteMasterPage', 'deleteObject', 'deletePage', 'deleteText', 'deselectAll', 'docChanged', 'duplicateObject', 'editMasterPage', 'exceptions', 'fileDialog', 'fileQuit', 'getActiveLayer', 'getAllObjects', 'getAllStyles', 'getAllText', 'getColor', 'getColorAsRGB', 'getColorNames', 'getColumnGap', 'getColumns', 'getCornerRadius', 'getDocName', 'getFillBlendmode', 'getFillColor', 'getFillShade', 'getFillTransparency', 'getFont', 'getFontNames', 'getFontSize', 'getGuiLanguage', 'getHGuides', 'getImageFile', 'getImageScale', 'getLayerBlendmode', 'getLayerTransparency', 'getLayers', 'getLineBlendmode', 'getLineCap', 'getLineColor', 'getLineJoin', 'getLineShade', 'getLineSpacing', 'getLineStyle', 'getLineTransparency', 'getLineWidth', 'getObjectType', 'getPageItems', 'getPageMargins', 'getPageNMargins', 'getPageNSize', 'getPageSize', 'getPageType', 'getPosition', 'getProperty', 'getPropertyCType', 'getPropertyNames', 'getRotation', 'getSelectedObject', 'getSize', 'getText', 'getTextColor', 'getTextDistances', 'getTextLength', 'getTextLines', 'getTextShade', 'getUnit', 'getVGuides', 'getXFontNames', 'getval', 'gotoPage', 'groupObjects', 'haveDoc', 'hyphenateText', 'importPage', 'inch', 'insertText', 'isLayerFlow', 'isLayerLocked', 'isLayerOutlined', 'isLayerPrintable', 'isLayerVisible', 'isLocked', 'isPDFBookmark', 'isSpotColor', 'linkTextFrames', 'loadImage', 'loadStylesFromFile', 'lockObject', 'mainWindow', 'masterPageNames', 'messageBox', 'messagebarText', 'mm', 'moveObject', 'moveObjectAbs', 'moveSelectionToBack', 'moveSelectionToFront', 'newDoc', 'newDocDialog', 'newDocument', 'newPage', 'newStyleDialog', 'objectExists', 'openDoc', 'p', 'pageCount', 'pageDimension', 'placeEPS', 'placeODG', 'placeSVG', 'placeSXD', 'progressReset', 'progressSet', 'progressTotal', 'pt', 'qApp', 'redrawAll', 'renderFont', 'replaceColor', 'retval', 'rotateObject', 'rotateObjectAbs', 'saveDoc', 'saveDocAs', 'savePageAsEPS', 'scaleGroup', 'scaleImage', 'scribus_version', 'scribus_version_info', 'scrollDocument', 'selectObject', 'selectText', 'selectionCount', 'sentToLayer', 'setActiveLayer', 'setColumnGap', 'setColumns', 'setCornerRadius', 'setCursor', 'setDocType', 'setFillBlendmode', 'setFillColor', 'setFillShade', 'setFillTransparency', 'setFont', 'setFontSize', 'setGradientFill', 'setGradientStop', 'setHGuides', 'setImageOffset', 'setImageScale', 'setInfo', 'setLayerBlendmode', 'setLayerFlow', 'setLayerLocked', 'setLayerOutlined', 'setLayerPrintable', 'setLayerTransparency', 'setLayerVisible', 'setLineBlendmode', 'setLineCap', 'setLineColor', 'setLineJoin', 'setLineShade', 'setLineSpacing', 'setLineStyle', 'setLineTransparency', 'setLineWidth', 'setMargins', 'setMultiLine', 'setNewName', 'setPDFBookmark', 'setProperty', 'setRedraw', 'setScaleImageToFrame', 'setSpotColor', 'setStyle', 'setText', 'setTextAlignment', 'setTextColor', 'setTextDistances', 'setTextScalingH', 'setTextScalingV', 'setTextShade', 'setTextStroke', 'setUnit', 'setVGuides', 'sizeObject', 'statusMessage', 'textFlowMode', 'textOverflows', 'traceText', 'unGroupObject', 'unlinkTextFrames', 'valueDialog', 'warnings', 'zoomDocument', '\xb0']
